var MAX_STARTUP = 15 * ONE_SEC;  // 15 sec
var MAX_DECIMALS = 6;
var IMS = "If-Modified-Since";
var OLD = "Thu, 01 Jun 1970 00:00:00 GMT";

// update intervals
var ONE_SEC = 1000;  // 1 sec
var ONE_MIN = 60 * ONE_SEC;  // 1 min
var DEFAULT_MINE_UPDATE_INTERVAL = 10 * ONE_MIN;  // 10 min
var DEFAULT_EXCHANGE_UPDATE_INTERVAL = 10 * ONE_MIN;  // 10 min
var MIN_MINE_UPDATE_INTERVAL = ONE_MIN;  // 1 min
var MIN_EXCHANGE_UPDATE_INTERVAL = 3 * ONE_SEC;  // 3 sec
var mineUpdateInterval = DEFAULT_MINE_UPDATE_INTERVAL;
var exchangeUpdateInterval = DEFAULT_EXCHANGE_UPDATE_INTERVAL;

// docked/undocked
var HEIGHT = 68;
var EXPANDED_HEIGHT = 134;

// XMLHTTP objects
var xmlhttpExchangeRate = null;
var xmlhttpSecondaryExchange = null;
var xmlhttpCurrencyBid = null;
var xmlhttpPool1 = null;
var xmlhttpPool2 = null;
var xmlhttpPool3 = null;

// configuration variables (these are the settings on the first run)
var correction = 0;

var exchangeRateUrl = "";
var exchangeRateKey = "";
var sourceCurrency = "";
var targetCurrency = "";
var targetCurrencyAPIKey = "";
var mainCurrency = "";

var secondaryExchangeUrl = "";
var field1Label = "";
var field1Key = "";
var field2Label = "";
var field2Key = "";
var field3Label = "";
var field3Key = "";

var url1 = "";
var unpaidKey1 = "";
var paidKey1 = "";
var extraKey1 = "";
var hashKey1 = "";

var url2 = "";
var unpaidKey2 = "";
var paidKey2 = "";
var extraKey2 = "";
var hashKey2 = "";

var url3 = "";
var unpaidKey3 = "";
var paidKey3 = "";
var extraKey3 = "";
var hashKey3 = "";

var preset = 0;
var topField = 0;

var alertGreenType = 0;
var alertGreenFixed = 0;
var alertGreenTrailing = 0;
var alertRedType = 0;
var alertRedFixed = 0;
var alertRedTrailing = 0;

// variables
var exchangeRate = 0;
var field1 = 0;
var field2 = 0;
var field3 = 0;
var earned1 = 0;
var earned2 = 0;
var earned3 = 0;
var hash1 = 0;
var hash2 = 0;
var hash3 = 0;
var conversionRate = 1; // currency conversion coefficient
var timeoutRef = 0;
var exchTimeoutRef = 0;
var highestAmount = 0;
var lowestAmount = Number.POSITIVE_INFINITY;

// localization
var notAvailable;
var aLot;

document.onreadystatechange = function() {
	if (document.readyState == "complete") {
		// load localized text from HTML file
		notAvailable = document.getElementById('notAvailable').innerText;
		aLot = document.getElementById('aLot').innerText;

		System.Gadget.settingsUI = "Settings.html";
		System.Gadget.onSettingsClosed = load;

		// docking
		System.Gadget.onDock = checkDockState;
		System.Gadget.onUndock = checkDockState;

		if (System.Gadget.Settings.readString("init") == "") {
			// init is not set only on first run; so, set defaults
			System.Gadget.Settings.writeString("init", "init");
			System.Gadget.Settings.writeString("mainCurrency", mainCurrency);
			System.Gadget.Settings.write("correction", correction);
			System.Gadget.Settings.writeString("exchangeRateUrl", exchangeRateUrl);
			System.Gadget.Settings.writeString("exchangeRateKey", exchangeRateKey);
			System.Gadget.Settings.writeString("sourceCurrency", sourceCurrency);
			System.Gadget.Settings.writeString("targetCurrency", targetCurrency);
			System.Gadget.Settings.writeString("targetCurrencyAPIKey", targetCurrencyAPIKey);
			System.Gadget.Settings.write("mineUpdateInterval", mineUpdateInterval / ONE_MIN);
			System.Gadget.Settings.write("exchangeUpdateInterval", exchangeUpdateInterval / ONE_SEC);
			System.Gadget.Settings.writeString("field1Label", field1Label);
			System.Gadget.Settings.writeString("field1Key", field1Key);
			System.Gadget.Settings.writeString("field2Label", field2Label);
			System.Gadget.Settings.writeString("field2Key", field2Key);
			System.Gadget.Settings.writeString("field3Label", field3Label);
			System.Gadget.Settings.writeString("field3Key", field3Key);
			System.Gadget.Settings.write("preset", preset);
			System.Gadget.Settings.write("topField", topField);
			System.Gadget.Settings.write("alertGreenType", alertGreenType);
			System.Gadget.Settings.write("alertGreenFixed", alertGreenFixed);
			System.Gadget.Settings.write("alertGreenTrailing", alertGreenTrailing);
			System.Gadget.Settings.write("alertRedType", alertRedType);
			System.Gadget.Settings.write("alertRedFixed", alertRedFixed);
			System.Gadget.Settings.write("alertRedTrailing", alertRedTrailing);
		}
		// random pause on startup, so that multiple gadget instance don't fire off requests at the
		// same time
		setTimeout("load()", randomFromInterval(0, MAX_STARTUP));
	}
};

function load() {
	preset = System.Gadget.Settings.read("preset");

	secondaryExchangeUrl = System.Gadget.Settings.readString("secondaryExchangeUrl");
	field1Key = System.Gadget.Settings.readString("field1Key");
	if (field1Key == "")
		field1 = 0;
	field2Key = System.Gadget.Settings.readString("field2Key");
	if (field2Key == "")
		field2 = 0;
	field3Key = System.Gadget.Settings.readString("field3Key");
	if (field3Key == "")
		field3 = 0;

	field1Label = System.Gadget.Settings.readString("field1Label");
	if (field1Label == "")
		field1Label = notAvailable;
	field2Label = System.Gadget.Settings.readString("field2Label");
	if (field2Label == "")
		field2Label = notAvailable;
	field3Label = System.Gadget.Settings.readString("field3Label");
	if (field3Label == "")
		field3Label = notAvailable;

	document.getElementById('expLabel1').innerText = field1Label;
	document.getElementById('expLabel2').innerText = field2Label;
	document.getElementById('expLabel3').innerText = field3Label;

	topField = System.Gadget.Settings.read("topField");
	bottomFieldHidden = System.Gadget.Settings.read("bottomFieldHidden");

	mainCurrency = System.Gadget.Settings.readString("mainCurrency");

	// determine top field label
	var displayedMainCurrency = mainCurrency;
	if (topField == 6) {
		document.getElementById("container").setAttribute("className", "container-middle");
		document.getElementById("topField").style.display = "none";
		document.getElementById("bottomField").style.display = "";
	} else {
		document.getElementById("topField").style.display = "";

		switch (topField) {
		case 2:
			displayedMainCurrency = field1Label;
			break;
		case 3:
			displayedMainCurrency = field2Label;
			break;
		case 4:
			displayedMainCurrency = field3Label;
			break;
		}
		if (displayedMainCurrency == "")
			displayedMainCurrency = mainCurrency;

		// and what about bottom field?
		if (bottomFieldHidden) {
			document.getElementById("container").setAttribute("className", "container-middle");
			document.getElementById("bottomField").style.display = "none";
		} else {
			document.getElementById("container").setAttribute("className", "container");
			document.getElementById("bottomField").style.display = "";
		}
	}
	if (displayedMainCurrency == "")
		displayedMainCurrency = notAvailable;
	// and finally display it
	document.getElementById("mainCurrency").innerText = displayedMainCurrency;

	correction = System.Gadget.Settings.read("correction");
	if (correction == "" || isNaN(correction)) {
		correction = 0;
		System.Gadget.Settings.write("correction", correction);
	}

	exchangeRate = 0;
	exchangeRateUrl = System.Gadget.Settings.readString("exchangeRateUrl");
	exchangeRateKey = System.Gadget.Settings.readString("exchangeRateKey");

	sourceCurrency = System.Gadget.Settings.readString("sourceCurrency");
	if (sourceCurrency == "") {
		sourceCurrency = "USD";
		System.Gadget.Settings.writeString("sourceCurrency", sourceCurrency);
	}

	targetCurrency = System.Gadget.Settings.readString("targetCurrency");
	targetCurrencyAPIKey = System.Gadget.Settings.readString("targetCurrencyAPIKey");
	if (targetCurrency == "" || targetCurrency == sourceCurrency) {
		conversionRate = 1;
		redraw();
	}

	url1 = System.Gadget.Settings.readString("url1");
	unpaidKey1 = System.Gadget.Settings.readString("unpaidKey1");
	paidKey1 = System.Gadget.Settings.readString("paidKey1");
	extraKey1 = System.Gadget.Settings.readString("extraKey1");
	hashKey1 = System.Gadget.Settings.readString("hashKey1");
	if (url1 == "" || (unpaidKey1 == "" || paidKey1 == "" || extraKey1))
		earned1 = 0;
	if (url1 == "" || hashKey1 == "")
		hash1 = 0;

	url2 = System.Gadget.Settings.readString("url2");
	unpaidKey2 = System.Gadget.Settings.readString("unpaidKey2");
	paidKey2 = System.Gadget.Settings.readString("paidKey2");
	extraKey2 = System.Gadget.Settings.readString("extraKey2");
	hashKey2 = System.Gadget.Settings.readString("hashKey2");
	if (url2 == "" || (unpaidKey2 == "" || paidKey2 == "" || extraKey2))
		earned2 = 0;
	if (url2 == "" || hashKey2 == "")
		hash2 = 0;

	url3 = System.Gadget.Settings.readString("url3");
	unpaidKey3 = System.Gadget.Settings.readString("unpaidKey3");
	paidKey3 = System.Gadget.Settings.readString("paidKey3");
	extraKey3 = System.Gadget.Settings.readString("extraKey3");
	hashKey3 = System.Gadget.Settings.readString("hashKey3");
	if (url3 == "" || (unpaidKey3 == "" || paidKey3 == "" || extraKey3))
		earned3 = 0;
	if (url3 == "" || hashKey3 == "")
		hash3 = 0;

	mineUpdateInterval = System.Gadget.Settings.read("mineUpdateInterval");
	if (mineUpdateInterval == "") {
		mineUpdateInterval = DEFAULT_MINE_UPDATE_INTERVAL;
		System.Gadget.Settings.write("mineUpdateInterval", mineUpdateInterval / ONE_MIN);
	} else
		mineUpdateInterval *= ONE_MIN;
	if (mineUpdateInterval < MIN_MINE_UPDATE_INTERVAL) {
		mineUpdateInterval = MIN_MINE_UPDATE_INTERVAL;
		System.Gadget.Settings.write("mineUpdateInterval", mineUpdateInterval / ONE_MIN);
	}

	exchangeUpdateInterval = System.Gadget.Settings.read("exchangeUpdateInterval");
	if (exchangeUpdateInterval == "") {
		exchangeUpdateInterval = DEFAULT_EXCHANGE_UPDATE_INTERVAL;
		System.Gadget.Settings.write("exchangeUpdateInterval", exchangeUpdateInterval / ONE_SEC);
	} else
		exchangeUpdateInterval *= ONE_SEC;
	if (exchangeUpdateInterval < MIN_EXCHANGE_UPDATE_INTERVAL) {
		exchangeUpdateInterval = MIN_EXCHANGE_UPDATE_INTERVAL;
		System.Gadget.Settings.write("exchangeUpdateInterval", exchangeUpdateInterval / ONE_SEC);
	}

	var tempLowest = System.Gadget.Settings.read("lowestAmount");
	if (tempLowest == "" || tempLowest == "1.#INF")
		setLowest(Number.POSITIVE_INFINITY);
	if (System.Gadget.Settings.read("highestAmount") == "")
		setHighest(0);

	alertGreenType = System.Gadget.Settings.read("alertGreenType");
	if (alertGreenType == "" || isNaN(alertGreenType)) {
		alertGreenType = 0;
		System.Gadget.Settings.write("alertGreenType", alertGreenType);
	}

	alertRedType = System.Gadget.Settings.read("alertRedType");
	if (alertRedType == "" || isNaN(alertRedType)) {
		alertRedType = 0;
		System.Gadget.Settings.write("alertRedType", alertRedType);
	}

	alertGreenFixed = System.Gadget.Settings.read("alertGreenFixed");
	if (alertGreenFixed == "" || isNaN(alertGreenFixed)) {
		alertGreenFixed = 0;
		System.Gadget.Settings.write("alertGreenFixed", alertGreenFixed);
	}

	var alertGreenTrailingTemp = System.Gadget.Settings.read("alertGreenTrailing");
	if (alertGreenTrailingTemp == "" || isNaN(alertGreenTrailingTemp)) {
		alertGreenTrailingTemp = 0;
		System.Gadget.Settings.write("alertGreenTrailing", alertGreenTrailingTemp);
	} else if (alertGreenTrailingTemp != alertGreenTrailing) {
		setLowest(Number.POSITIVE_INFINITY);
	}
	alertGreenTrailing = alertGreenTrailingTemp;

	alertRedFixed = System.Gadget.Settings.read("alertRedFixed");
	if (alertRedFixed == "" || isNaN(alertRedFixed)) {
		alertRedFixed = 0;
		System.Gadget.Settings.write("alertRedFixed", alertRedFixed);
	}

	var alertRedTrailingTemp = System.Gadget.Settings.read("alertRedTrailing");
	if (alertRedTrailingTemp == "" || isNaN(alertRedTrailingTemp)) {
		alertRedTrailingTemp = 0;
		System.Gadget.Settings.write("alertRedTrailing", alertRedTrailingTemp);
	} else if (alertRedTrailingTemp != alertRedTrailing) {
		setHighest(0);
	}
	alertRedTrailing = alertRedTrailingTemp;

	updateExchangeData();
	updateMineData();
}

function checkDockState() {
	var bodyStyle = document.body.style;

	var expanded1 = document.getElementById("expanded1");
	var expanded2 = document.getElementById("expanded2");
	var expanded3 = document.getElementById("expanded3");
	if (System.Gadget.docked) {
		bodyStyle.height = HEIGHT;
		System.Gadget.background = "../background.png";
		expanded1.style.display = "none";
		expanded2.style.display = "none";
		expanded3.style.display = "none";
	} else {
		bodyStyle.height = EXPANDED_HEIGHT;
		System.Gadget.background = "../backgroundExpanded.png";
		expanded1.style.display = "";
		expanded2.style.display = "";
		expanded3.style.display = "";
	}
}

function updateMineData() {
	try {
		if (url1 != "") {
			xmlhttpPool1 = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpPool1.onReadyStateChange = function() {
				if (xmlhttpPool1.readyState == 4 && xmlhttpPool1.status == 200) {
					earned1 = 0;
					earned1 = parse(xmlhttpPool1, unpaidKey1, 0) + parse(xmlhttpPool1, paidKey1, 0) + parse(xmlhttpPool1, extraKey1, 0);
					hash1 = parse(xmlhttpPool1, hashKey1, hash1);
					redraw();
				}
			};
		}

		if (url2 != "") {
			xmlhttpPool2 = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpPool2.onReadyStateChange = function() {
				if (xmlhttpPool2.readyState == 4 && xmlhttpPool2.status == 200) {
					earned2 = 0;
					earned2 = parse(xmlhttpPool2, unpaidKey2, 0) + parse(xmlhttpPool2, paidKey2, 0) + parse(xmlhttpPool2, extraKey2, 0);
					hash2 = parse(xmlhttpPool2, hashKey2, hash2);
					redraw();
				}
			};
		}

		if (url3 != "") {
			xmlhttpPool3 = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpPool3.onReadyStateChange = function() {
				if (xmlhttpPool3.readyState == 4 && xmlhttpPool3.status == 200) {
					earned3 = 0;
					earned3 = parse(xmlhttpPool3, unpaidKey3, 0) + parse(xmlhttpPool3, paidKey3, 0) + parse(xmlhttpPool3, extraKey3, 0);
					hash3 = parse(xmlhttpPool3, hashKey3, hash3);
					redraw();
				}
			};
		}

		if (url1 != "") {
			xmlhttpPool1.open("GET", url1, true);
			xmlhttpPool1.setRequestHeader(IMS, OLD);
			xmlhttpPool1.send();
		}
		if (url2 != "") {
			xmlhttpPool2.open("GET", url2, true);
			xmlhttpPool2.setRequestHeader(IMS, OLD);
			xmlhttpPool2.send();
		}
		if (url3 != "") {
			xmlhttpPool3.open("GET", url3, true);
			xmlhttpPool3.setRequestHeader(IMS, OLD);
			xmlhttpPool3.send();
		}
	} catch (ex) {
	}

	clearTimeout(timeoutRef);
	timeoutRef = setTimeout("updateMineData()", mineUpdateInterval);
}

function updateExchangeData() {
	try {
		if (exchangeRateUrl != "") {
			xmlhttpExchangeRate = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpExchangeRate.onReadyStateChange = function() {
				if (xmlhttpExchangeRate.readyState == 4 && xmlhttpExchangeRate.status == 200) {
					exchangeRate = parse(xmlhttpExchangeRate, exchangeRateKey, exchangeRate);

					if (secondaryExchangeUrl == "" || exchangeRateUrl == secondaryExchangeUrl) {
						if (field1Key != "")
							field1 = parse(xmlhttpExchangeRate, field1Key, field1);
						if (field2Key != "")
							field2 = parse(xmlhttpExchangeRate, field2Key, field2);
						if (field3Key != "")
							field3 = parse(xmlhttpExchangeRate, field3Key, field3);
					}

					redraw();
				}
			};
		}

		if (!System.Gadget.docked && secondaryExchangeUrl != "" && exchangeRateUrl != secondaryExchangeUrl &&
				(field1Key != "" || field2Key != "" || field3Key != "")) {
			xmlhttpSecondaryExchange = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpSecondaryExchange.onReadyStateChange = function() {
				if (xmlhttpSecondaryExchange.readyState == 4 && xmlhttpSecondaryExchange.status == 200) {
					if (field1Key != "")
						field1 = parse(xmlhttpSecondaryExchange, field1Key, field1);
					if (field2Key != "")
						field2 = parse(xmlhttpSecondaryExchange, field2Key, field2);
					if (field3Key != "")
						field3 = parse(xmlhttpSecondaryExchange, field3Key, field3);

					redraw();
				}
			};
		}

		if (targetCurrency != "" && targetCurrency != sourceCurrency) {
			xmlhttpCurrencyBid = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttpCurrencyBid.onReadyStateChange = function() {
				if (xmlhttpCurrencyBid.readyState == 4 && xmlhttpCurrencyBid.status == 200) {
					var tmp = parse(xmlhttpCurrencyBid, sourceCurrency + "_" + targetCurrency, conversionRate);
					if (!isNaN(tmp)) {
						conversionRate = tmp;
					} else {
						conversionRate = 0;
					}
					redraw();
				}
			};
		}

		if (exchangeRateUrl != "") {
			xmlhttpExchangeRate.open("GET", exchangeRateUrl, true);
			xmlhttpExchangeRate.setRequestHeader(IMS, OLD);
			xmlhttpExchangeRate.send();
		}

		if (!System.Gadget.docked && secondaryExchangeUrl != "" && exchangeRateUrl != secondaryExchangeUrl &&
				(field1Key != "" || field2Key != "" || field3Key != "")) {
			xmlhttpSecondaryExchange.open("GET", secondaryExchangeUrl, true);
			xmlhttpSecondaryExchange.setRequestHeader(IMS, OLD);
			xmlhttpSecondaryExchange.send();
		}

		if (targetCurrency != "" && targetCurrency != sourceCurrency) {
			xmlhttpCurrencyBid.open("GET", "https://free.currencyconverterapi.com/api/v6/convert?q=" + sourceCurrency + "_" + targetCurrency + "&apiKey=" + targetCurrencyAPIKey + "&compact=ultra", true);
			xmlhttpCurrencyBid.setRequestHeader(IMS, OLD);
			xmlhttpCurrencyBid.send();
		}
	} catch (ex) {
	}

	clearTimeout(exchTimeoutRef);
	exchTimeoutRef = setTimeout("updateExchangeData()", exchangeUpdateInterval);
}

function redraw() {
	// calculate amount
	var amount = 0;
	if (topField == 1) {
		// show primary exchange rate
		amount = exchangeRate;
	} else if (topField == 2) {
		// show secondary exchange rate (field 1)
		amount = field1;
	} else if (topField == 3) {
		// show secondary exchange rate (field 2)
		amount = field2;
	} else if (topField == 4) {
		// show secondary exchange rate (field 3)
		amount = field3;
	} else if (topField == 5) {
		// show hash rate
		amount = hash1 + hash2 + hash3;
	} else {
		// show correction + pools amount (default), or hidden
		amount = earned1 + earned2 + earned3 + correction;
	}
	var mainCurrencyAmount = notAvailable;
	if (amount != 0)
		mainCurrencyAmount = format(amount);

	// convert to currency
	var currencyAmount = amount * exchangeRate;
	var displayedCurrency = sourceCurrency;
	if (targetCurrency != "" && targetCurrency != sourceCurrency) {
		currencyAmount *= conversionRate;
		if (conversionRate == 0)
			// target currency is possibly invalid
			displayedCurrency = "???";
		else
			displayedCurrency = targetCurrency;
	}

	// update highs and lows
	if (currencyAmount > 0 && currencyAmount < lowestAmount)
		setLowest(currencyAmount);
	if (currencyAmount > highestAmount)
		setHighest(currencyAmount);

	// make sure that amounts fit in the allocated space
	if (currencyAmount == 0)
		currencyAmount = notAvailable;
	else
		currencyAmount = format(currencyAmount);

	field1Amount = format(field1);
	field2Amount = format(field2);
	field3Amount = format(field3);

	// display currency and amounts
	document.getElementById('value').innerText = mainCurrencyAmount;
	document.getElementById('expValue1').innerText = field1Amount;
	document.getElementById('expValue2').innerText = field2Amount;
	document.getElementById('expValue3').innerText = field3Amount;
	document.getElementById('targetCurrency').innerText = displayedCurrency;
	document.getElementById('targetCurrencyValue').innerText = currencyAmount;

	// color amount if alert is set
	if ((alertRedType == 0 && alertRedFixed > 0 && currencyAmount < alertRedFixed) ||
			(alertRedType == 1 && alertRedTrailing > 0 && currencyAmount < highestAmount - alertRedTrailing))
		document.getElementById('targetCurrencyValue').setAttribute('className','value red');
	else if ((alertGreenType == 0 && alertGreenFixed > 0 && currencyAmount > alertGreenFixed) ||
			(alertGreenType == 1 && alertGreenTrailing > 0 && currencyAmount > lowestAmount + alertGreenTrailing))
		document.getElementById('targetCurrencyValue').setAttribute('className','value green');
	else
		document.getElementById('targetCurrencyValue').setAttribute('className','value');
}

function showDesc() {
	var note = System.Gadget.Settings.readString("note");
	if (note != "") {
		document.getElementById("container").style.display = "none";
		document.getElementById("desc").style.display = "";
		document.getElementById("descText").innerText = note;
	}
}

function hideDesc() {
	document.getElementById("desc").style.display = "none";
	document.getElementById("container").style.display = "";
}

function parse(xmlhttp, jsonKey, defaultValue) {
	var regex = new RegExp('"' + jsonKey + '": {0,1}"{0,1}([0-9\.]+)');

	if (xmlhttp.readyState == 4 && jsonKey != "") {
		// try parsing with regex
		var temp = regex.exec(xmlhttp.responseText);
		if (temp != null && temp.length == 2) {
			var result = parseFloat(temp[1]);
		}

		// if regex fails, try parsing as JSON key
		if (!result || isNaN(result)) {
			var json = eval("(" + xmlhttp.responseText + ")");
			result = parseFloat(eval("(" + jsonKey + ")"));
		}

		// return whatever you got
		if (result && !isNaN(result)) {
			return result;
		}
	}

	return defaultValue;
}

// How many decimals to display.
function determineDecimals(amount) {
	var max = howManyDecimals(amount);

	// handle negative amounts which have one decimal less
	// available because of the minus sign by increasing
	// amount for one order of magnitute and making it
	// positive to be resolved as bigger positive number,
	// that is, with less available digits for decimals
	var adjustedAmount = amount < 0 ? -amount * 10 : amount;

	// figure out decimals; this is
	for (var i = 0; i <= MAX_DECIMALS; i++)
		if (max == i || adjustedAmount >= Math.pow(10, (MAX_DECIMALS - i)))
			// max decimals for negative amount: 5, for positive: 6
			return i;

	return MAX_DECIMALS;
}

// How many decimals an amount has.
function howManyDecimals(amount) {
	var tmp = amount + "";
	if (tmp.indexOf(".") > -1)
		return tmp.length - tmp.indexOf(".") - 1;
	else
		return MAX_DECIMALS;
}

function abbreviate(amount) {
	var multiples = [ '', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y' ];
	var fractions = [ '', 'm', '&mu;', 'n', 'p', 'f', 'a', 'z', 'y' ];
	if (amount == 0)
		return amount;
	var orderOfMagnitude = parseInt(Math.floor(Math.log(Math.abs(amount)) / Math.log(1000)));
	var positiveOrder = Math.abs(orderOfMagnitude);
	var suffix = "";
	if (positiveOrder > 8)
		// limit to less than a yotta-amount (nobody has that much money)
		return aLot;
	else if (orderOfMagnitude > 0) {
		// multiples
		amount = amount / Math.pow(1000, positiveOrder);
		suffix = multiples[positiveOrder];
	} else if (orderOfMagnitude < 0) {
		// fractions
		amount = amount * Math.pow(1000, positiveOrder);
		suffix = fractions[positiveOrder];
	}
	// take away one decimal for suffix
	var decimals = determineDecimals(amount);
	if (decimals > 1)
		decimals--;
	return amount.toFixed(decimals) + suffix;
}

function format(amount) {
	var absAmount = Math.abs(amount);
	if (absAmount >= 100000000 || absAmount <= 0.000001) {
		// make the amount fit into 8-9 characters
		return abbreviate(amount);
	} else {
		var power = determineDecimals(amount);
		var decimals = Math.pow(10, power);
		return Math.round(amount * decimals) / decimals;
	}
}

function setHighest(amount) {
	highestAmount = amount;
	System.Gadget.Settings.write("highestAmount", highestAmount);
}

function setLowest(amount) {
	lowestAmount = amount;
	System.Gadget.Settings.write("lowestAmount", lowestAmount);
}

function randomFromInterval(from, to) {
  return Math.floor(Math.random() * (to - from + 1) + from);
}
