﻿var numberRegex = /[^\d.,-]/g;
var positiveNumberRegex = /[^\d.,]/g;

function load() {
	System.Gadget.onSettingsClosing = onClosing;

	// set preset to what was last applied
	var preset = System.Gadget.Settings.read("preset");
	document.presets.preset[preset].checked = true;

	document.getElementById('mainCurrency').innerText = System.Gadget.Settings.readString("mainCurrency");
	document.getElementById('correction').innerText = System.Gadget.Settings.read("correction");
	document.getElementById('note').innerText = System.Gadget.Settings.read("note");

	var topField = System.Gadget.Settings.read("topField");
	document.getElementById('topField' + topField).selected = true;
	document.getElementById('bottomField').checked = System.Gadget.Settings.read("bottomFieldHidden");

	document.getElementById('exchangeRateUrl').innerText  = System.Gadget.Settings.readString("exchangeRateUrl");
	document.getElementById('exchangeRateKey').innerText  = System.Gadget.Settings.readString("exchangeRateKey");
	document.getElementById('sourceCurrency').innerText = System.Gadget.Settings.readString("sourceCurrency");
	document.getElementById('targetCurrency').innerText = System.Gadget.Settings.readString("targetCurrency");
	document.getElementById('targetCurrencyAPIKey').innerText = System.Gadget.Settings.readString("targetCurrencyAPIKey");

	document.getElementById('secondaryExchangeUrl').innerText  = System.Gadget.Settings.readString("secondaryExchangeUrl");
	document.getElementById('field1Label').innerText = System.Gadget.Settings.readString("field1Label");
	document.getElementById('field1Key').innerText = System.Gadget.Settings.readString("field1Key");
	document.getElementById('field2Label').innerText = System.Gadget.Settings.readString("field2Label");
	document.getElementById('field2Key').innerText = System.Gadget.Settings.readString("field2Key");
	document.getElementById('field3Label').innerText = System.Gadget.Settings.readString("field3Label");
	document.getElementById('field3Key').innerText = System.Gadget.Settings.readString("field3Key");

	document.getElementById('url1').innerText = System.Gadget.Settings.readString("url1");
	document.getElementById('unpaidKey1').innerText = System.Gadget.Settings.readString("unpaidKey1");
	document.getElementById('paidKey1').innerText = System.Gadget.Settings.readString("paidKey1");
	document.getElementById('extraKey1').innerText = System.Gadget.Settings.readString("extraKey1");
	document.getElementById('hashKey1').innerText = System.Gadget.Settings.readString("hashKey1");

	document.getElementById('url2').innerText = System.Gadget.Settings.readString("url2");
	document.getElementById('unpaidKey2').innerText = System.Gadget.Settings.readString("unpaidKey2");
	document.getElementById('paidKey2').innerText = System.Gadget.Settings.readString("paidKey2");
	document.getElementById('extraKey2').innerText = System.Gadget.Settings.readString("extraKey2");
	document.getElementById('hashKey2').innerText = System.Gadget.Settings.readString("hashKey2");

	document.getElementById('url3').innerText = System.Gadget.Settings.readString("url3");
	document.getElementById('unpaidKey3').innerText = System.Gadget.Settings.readString("unpaidKey3");
	document.getElementById('paidKey3').innerText = System.Gadget.Settings.readString("paidKey3");
	document.getElementById('extraKey3').innerText = System.Gadget.Settings.readString("extraKey3");
	document.getElementById('hashKey3').innerText = System.Gadget.Settings.readString("hashKey3");

	document.getElementById('mineUpdateInterval').innerText = System.Gadget.Settings.read("mineUpdateInterval");
	document.getElementById('exchangeUpdateInterval').innerText = System.Gadget.Settings.read("exchangeUpdateInterval");

	var alertGreenType = System.Gadget.Settings.read("alertGreenType");
	document.getElementById('alertGreenType' + alertGreenType).selected = true;
	document.getElementById('alertGreenFixed').innerText = System.Gadget.Settings.read("alertGreenFixed");
	document.getElementById('alertGreenTrailing').innerText = System.Gadget.Settings.read("alertGreenTrailing");
	var lowestAmount = System.Gadget.Settings.read("lowestAmount");
	if (lowestAmount == "1.#INF")
		lowestAmount = "";
	document.getElementById('lowestAmount').innerText = lowestAmount;

	var alertRedType = System.Gadget.Settings.read("alertRedType");
	document.getElementById('alertRedType' + alertRedType).selected = true;
	document.getElementById('alertRedFixed').innerText = System.Gadget.Settings.read("alertRedFixed");
	document.getElementById('alertRedTrailing').innerText = System.Gadget.Settings.read("alertRedTrailing");
	var highest = System.Gadget.Settings.read("highestAmount");
	document.getElementById('highestAmount').innerText = highest;

	flashBottom(true);
	displayGreenAlert();
	displayRedAlert();
}

function onClosing(event) {
	if (event.closeAction == event.Action.commit) {
		System.Gadget.Settings.writeString("mainCurrency", trim(document.getElementById('mainCurrency').value));

		var correction = parseFloat(document.getElementById('correction').value.replace(numberRegex, "").replace(",", ".")) || "";
		System.Gadget.Settings.write("correction", correction);
		var mineUpdateInterval = parseInt(document.getElementById('mineUpdateInterval').value.replace(positiveNumberRegex, "").replace(",", ".")) || "";
		System.Gadget.Settings.write("mineUpdateInterval", mineUpdateInterval);
		var exchangeUpdateInterval = parseInt(document.getElementById('exchangeUpdateInterval').value.replace(positiveNumberRegex, "").replace(",", ".")) || "";

		System.Gadget.Settings.writeString("note", document.getElementById('note').value);

		var topField = document.getElementById("topField");
		var topFieldSelected = topField.options[topField.selectedIndex].value;
		System.Gadget.Settings.write("topField", topFieldSelected);
		System.Gadget.Settings.write("bottomFieldHidden", document.getElementById("bottomField").checked);

		System.Gadget.Settings.writeString("exchangeRateUrl", trim(document.getElementById('exchangeRateUrl').value));
		System.Gadget.Settings.writeString("exchangeRateKey", trim(document.getElementById('exchangeRateKey').value));
		var sourceCurrency = trim(document.getElementById('sourceCurrency').value.toUpperCase());
		System.Gadget.Settings.writeString("sourceCurrency", sourceCurrency);
		var targetCurrency = trim(document.getElementById('targetCurrency').value.toUpperCase());
		System.Gadget.Settings.writeString("targetCurrency", targetCurrency);
		System.Gadget.Settings.writeString("targetCurrencyAPIKey", trim(document.getElementById('targetCurrencyAPIKey').value));
		if (targetCurrency != "" && targetCurrency != sourceCurrency && exchangeUpdateInterval < 36) {
			// because of free.currencyconverterapi.com limits
			exchangeUpdateInterval = 36;
		}
		System.Gadget.Settings.write("exchangeUpdateInterval", exchangeUpdateInterval);

		System.Gadget.Settings.writeString("secondaryExchangeUrl", trim(document.getElementById('secondaryExchangeUrl').value));
		System.Gadget.Settings.writeString("field1Label", trim(document.getElementById('field1Label').value));
		System.Gadget.Settings.writeString("field1Key", trim(document.getElementById('field1Key').value));
		System.Gadget.Settings.writeString("field2Label", trim(document.getElementById('field2Label').value));
		System.Gadget.Settings.writeString("field2Key", trim(document.getElementById('field2Key').value));
		System.Gadget.Settings.writeString("field3Label", trim(document.getElementById('field3Label').value));
		System.Gadget.Settings.writeString("field3Key", trim(document.getElementById('field3Key').value));

		System.Gadget.Settings.writeString("url1", trim(document.getElementById('url1').value));
		System.Gadget.Settings.writeString("unpaidKey1", trim(document.getElementById('unpaidKey1').value));
		System.Gadget.Settings.writeString("paidKey1", trim(document.getElementById('paidKey1').value));
		System.Gadget.Settings.writeString("extraKey1", trim(document.getElementById('extraKey1').value));
		System.Gadget.Settings.writeString("hashKey1", trim(document.getElementById('hashKey1').value));

		System.Gadget.Settings.writeString("url2", trim(document.getElementById('url2').value));
		System.Gadget.Settings.writeString("unpaidKey2", trim(document.getElementById('unpaidKey2').value));
		System.Gadget.Settings.writeString("paidKey2", trim(document.getElementById('paidKey2').value));
		System.Gadget.Settings.writeString("extraKey2", trim(document.getElementById('extraKey2').value));
		System.Gadget.Settings.writeString("hashKey2", trim(document.getElementById('hashKey2').value));

		System.Gadget.Settings.writeString("url3", trim(document.getElementById('url3').value));
		System.Gadget.Settings.writeString("unpaidKey3", trim(document.getElementById('unpaidKey3').value));
		System.Gadget.Settings.writeString("paidKey3", trim(document.getElementById('paidKey3').value));
		System.Gadget.Settings.writeString("extraKey3", trim(document.getElementById('extraKey3').value));
		System.Gadget.Settings.writeString("hashKey3", trim(document.getElementById('hashKey3').value));

		var alertGreenType = document.getElementById("alertGreenType");
		var alertGreenTypeSelected = alertGreenType.options[alertGreenType.selectedIndex].value;
		System.Gadget.Settings.write("alertGreenType", alertGreenTypeSelected);
		var alertGreenFixed = parseFloat(document.getElementById('alertGreenFixed').value.replace(numberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("alertGreenFixed", alertGreenFixed);
		var alertGreenTrailing = parseFloat(document.getElementById('alertGreenTrailing').value.replace(positiveNumberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("alertGreenTrailing", alertGreenTrailing);
		var lowestAmount = document.getElementById('lowestAmount').value;
		if (lowestAmount == "")
			lowestAmount = Number.POSITIVE_INFINITY;
		else
			lowestAmount = parseFloat(lowestAmount.replace(positiveNumberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("lowestAmount", lowestAmount);

		var alertRedType = document.getElementById("alertRedType");
		var alertRedTypeSelected = alertRedType.options[alertRedType.selectedIndex].value;
		System.Gadget.Settings.write("alertRedType", alertRedTypeSelected);
		var alertRedFixed = parseFloat(document.getElementById('alertRedFixed').value.replace(numberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("alertRedFixed", alertRedFixed);
		var alertRedTrailing = parseFloat(document.getElementById('alertRedTrailing').value.replace(positiveNumberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("alertRedTrailing", alertRedTrailing);
		var highestAmount = document.getElementById('highestAmount').value;
		if (highestAmount == "")
			highestAmount = 0;
		else
			highestAmount = parseFloat(highestAmount.replace(positiveNumberRegex, "").replace(",", "."));
		System.Gadget.Settings.write("highestAmount", highestAmount);

		event.cancel = false;
	}
}

function flashBottom(initial) {
	var topField = document.getElementById("topField");
	var topFieldValue = topField.options[topField.selectedIndex].value;
	if (topFieldValue == 6) {
		document.getElementById("showBottom").style.display = "none";
		document.getElementById("bottomField").checked = false;
	} else {
		document.getElementById("showBottom").style.display = "";
	}

	if (!initial) {
		// changing displayed value, so highest and lowest are not accurate anymore
		resetLowest();
		resetHighest();
	}

	return false;
}

function displayGreenAlert() {
	var alertGreenType = document.getElementById("alertGreenType");
	var alertGreenTypeValue = alertGreenType.options[alertGreenType.selectedIndex].value;
	if (alertGreenTypeValue == 0) {
		document.getElementById("alertGreenTrailingDiv").style.display = "none";
		document.getElementById("alertGreenFixedDiv").style.display = "";
	} else {
		document.getElementById("alertGreenFixedDiv").style.display = "none";
		document.getElementById("alertGreenTrailingDiv").style.display = "";
	}

	return false;
}

function displayRedAlert() {
	var alertRedType = document.getElementById("alertRedType");
	var alertRedTypeValue = alertRedType.options[alertRedType.selectedIndex].value;
	if (alertRedTypeValue == 0) {
		document.getElementById("alertRedTrailingDiv").style.display = "none";
		document.getElementById("alertRedFixedDiv").style.display = "";
	} else {
		document.getElementById("alertRedFixedDiv").style.display = "none";
		document.getElementById("alertRedTrailingDiv").style.display = "";
	}

	return false;
}

function resetLowest() {
	document.getElementById("lowestAmount").innerText = "";
	return false;
}

function resetHighest() {
	document.getElementById("highestAmount").innerText = "";
	return false;
}

function applyPresets(form) {
	var selected = "none";
	for (var i = 0; i < form.preset.length; i++) {
		if (form.preset[i].checked) {
			selected = form.preset[i].value;
			System.Gadget.Settings.write("preset", i);
		}
	}

	if (selected == "trading") {
		document.getElementById("correction").innerText = "1";
		document.getElementById("mineUpdateInterval").innerText = "10";
		document.getElementById("exchangeUpdateInterval").innerText = "60";
		document.getElementById("exchangeRateUrl").innerText = "";
		document.getElementById("exchangeRateKey").innerText = "last";
		document.getElementById("sourceCurrency").innerText = "";
		document.getElementById("targetCurrency").innerText = "";
		document.getElementById("secondaryExchangeUrl").innerText = "";
		document.getElementById("field1Label").innerText = "";
		document.getElementById("field1Key").innerText = "";
		document.getElementById("field2Label").innerText = "";
		document.getElementById("field2Key").innerText = "";
		document.getElementById("field3Label").innerText = "";
		document.getElementById("field3Key").innerText = "";
	} else if (selected == "mining") {
		document.getElementById("correction").innerText = "0";
		document.getElementById("mineUpdateInterval").innerText = "10";
		document.getElementById("exchangeUpdateInterval").innerText = "600";
		document.getElementById("exchangeRateUrl").innerText = "";
		document.getElementById("exchangeRateKey").innerText = "";
		document.getElementById("sourceCurrency").innerText = "";
		document.getElementById("targetCurrency").innerText = "";
		document.getElementById("secondaryExchangeUrl").innerText = "";
		document.getElementById("field1Label").innerText = "";
		document.getElementById("field1Key").innerText = "";
		document.getElementById("field2Label").innerText = "";
		document.getElementById("field2Key").innerText = "";
		document.getElementById("field3Label").innerText = "";
		document.getElementById("field3Key").innerText = "";
	}

	return false;
}

// thanks to http://blog.stevenlevithan.com/archives/faster-trim-javascript
function trim(str) {
	var str = str.replace(/^\s\s*/, ''),
		ws = /\s/,
		i = str.length;
	while (ws.test(str.charAt(--i)));
	return str.slice(0, i + 1);
}

function onFocus(el) {
	if (window.copyToClipboard && window.copyToClipboard(el)) {
		document.getElementById('noteCopied').style.display = '';
	} else {
		document.getElementById('noteNotCopied').style.display = '';
	}
	window.scrollTo(0, document.body.scrollHeight);
}

function onBlur() {
	document.getElementById('noteCopied').style.display = 'none';
	document.getElementById('noteNotCopied').style.display = 'none';
}

window.copyToClipboard = function(source) {
	source.select();
	if (window.clipboardData) {
		clipboardData.setData('Text', source.value);
		return 1;
	} else {
		return 0;
	}
}
